<template>
  <article class="view view--identity-user-profile">
    <LoadingSpinner v-if="loading" />
    <div class="user-profile__components" v-if="loaded">
      <component v-for="component in components" :key="component.name" :is="component" :user="user" />
    </div>
  </article>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useRoute } from 'vue-router'
import { useStore } from 'vuex'
import { ValidationHelper, LoadingSpinner, useApi, useNotification } from '../../../core'
import { useUserAddOn } from '../../plugins/user-add-on-plugin.js'
import UsersApi from '../../api/users-api.js'

export default {
  name: 'IdentityUserProfileView',
  emits: ['loaded'],
  components: {
    LoadingSpinner,
  },
  setup(_, context) {
    const route = useRoute()
    const store = useStore()
    const api = useApi()
    const notify = useNotification()
    const userAddOn = useUserAddOn()
    const usersApi = new UsersApi(api)

    const user = ref(undefined)
    const loading = ref(false)
    const loaded = ref(false)

    const username = computed(() => {
      return ValidationHelper.getString(route.params.username, '')
    })

    const title = computed(() => {
      return username.value
    })

    const breadcrumbs = computed(() => {
      return [
        {
          text: 'Users',
          route: { name: 'identity-users' },
        },
        {
          text: title.value,
          route: null, // No link to self
        },
      ]
    })

    const components = computed(() => {
      return userAddOn.profileComponents
    })

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false
      user.value = null

      try {
        const response = await usersApi.readAsync(username.value, { expand: 'all' })
        user.value = response.data
        loaded.value = true
      } catch (ex) {
        notify.error('There was a problem getting the user.', ex)
        return
      } finally {
        loading.value = false
      }

      context.emit('loaded', user.value)
    }

    onMounted(async () => {
      const buttons =
        username.value === store.state.identity.session.username
          ? [
              {
                text: 'Edit',
                iconClass: 'bi bi-pencil-fill',
                route: { name: 'identity-account-edit' },
              },
            ]
          : []

      store.dispatch('core/setTitle', title.value)
      store.dispatch('core/setBreadcrumbs', breadcrumbs.value)
      store.dispatch('core/setTitleButtons', buttons)

      await loadAsync()
    })

    return {
      user,
      loading,
      loaded,
      username,
      title,
      breadcrumbs,
      components,
    }
  },
}
</script>

<style lang="scss">
@use '../../../core/sass/vars';

.user-profile__components {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  align-items: center;
  justify-content: center;
  gap: vars.$spacing;
}
</style>
